﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlanetaryDomination
{
    public class BattleAI
    {
        public Sector BattleSector;
        BattleSector tempsec;
        public int DefenderIndex, AttackerIndex, ActDefender, ActAttacker, BestTargetIndex, BestSectorIndex;
        public GameData Gamedat;
        float BestTargetScore, ActTargetScore;
        List<Unit> Attackers, Defenders;
        BattleManager BattleMan;
        int[] DefenderFrontSectors;
        int[] DefenderBackSectors;
        int[] AttackerFrontSectors;
        int[] AttackerBackSectors;
        bool DefenderWon;

        public BattleAI(Sector sect, GameData game, BattleManager bm)
        {
            ActDefender = ActAttacker = 0;
            BattleSector = sect;
            Attackers = sect.Attackers;
            Defenders = sect.Units;
            BattleMan = bm;
            Gamedat = game;
            if (8 != sect.Owner) // der sector gehört dem spieler
                DefenderIndex = sect.Owner;
            else// es sind nur seine einheiten dort stationiert
                DefenderIndex = Defenders[0].Owner;    // angreifer und verteidiger merken da am ende keine einheiten mehr übrig sind an denen man die änderungen (übernahme) festmachen kann
            AttackerIndex = Attackers[0].Owner;
            DefenderFrontSectors = new int[] {3,9,15,4,10,16,5,11,17};
            DefenderBackSectors = new int[] {5,11,17,4,10,16,3,9,15};
            AttackerFrontSectors = new int[] {2,8,14,1,7,13,0,6,12};
            AttackerBackSectors = new int[] {0,6,12,1,7,13,2,8,14};
        }
        public void Autofight()
        {
            AutoPlaceAttackers();
            AutoPlaceDefenders();
            while (!BattleOver())
            {// einen nach dem anderen ziehen lassen bis eine seite zerstört
                AutoMoveDefender();
                AutoMoveAttacker();
            }
        }
        public void Playerfight()
        {// platziert die computerspieler und setzt den modus für den spieler seine einheiten zu setzen
            AutoPlaceAttackers();   // das setzen evtl noch in abhängigkeit vom spieler machen aber erstmal automatisch
            AutoPlaceDefenders();
        }
        public void AutoPlaceAttackers()
        {// platziert die angreifer automatisch (linke seite)
            for (int i = 0; i < Attackers.Count; i++)
            {
                if ((0 == Attackers[i].Type) || (1 == Attackers[i].Type) || (6 == Attackers[i].Type) || (7 == Attackers[i].Type))
                {// prospektor, basemodule, artillery, building hinten platzieren
                    tempsec = GetFreeAttackerBack();
                    tempsec.Unit = Attackers[i];
                    Attackers[i].Battlesec = tempsec.Number;
                }
                else
                {
                    tempsec = GetFreeAttackerFront();
                    tempsec.Unit = Attackers[i];
                    Attackers[i].Battlesec = tempsec.Number;
                }
            }
        }
        public void AutoPlaceDefenders()
        {// platziert die verteidiger automatisch (rechte seite)
            for (int i = 0; i < Defenders.Count; i++)
            {
                if ((0 == Defenders[i].Type) || (1 == Defenders[i].Type) || (6 == Defenders[i].Type) || (7 == Defenders[i].Type))
                {// prospektor, basemodule, artillery, building hinten platzieren
                    tempsec = GetFreeDefenderBack();
                    tempsec.Unit = Defenders[i];
                    Defenders[i].Battlesec = tempsec.Number;
                }
                else
                {
                    tempsec = GetFreeDefenderFront();
                    tempsec.Unit = Defenders[i];
                    Defenders[i].Battlesec = tempsec.Number;
                }
            }
        }
        public bool BattleOver()
        {// prüft ob kamp vorbei ist
            if (0 == Defenders.Count) //wenn attacker 0 passiert nichts, wenn defender 0 werden attacker einheiten in units rüberkopiert und owner des sektors geändert und kampf beendet
            {// die verteidiger sind unterlegen also die angreifer als units setzen
                for (int i = 0; i < Attackers.Count; i++)
                {
                    Gamedat.Players[DefenderIndex].Units.Units.Add(Attackers[i]);
                    BattleSector.Units.Add(Attackers[i]);
                }
                BattleSector.Attackers.Clear();
                DefenderWon = false;
            }
            else
                DefenderWon = true;
            return ((0 == Defenders.Count) || (0 == Attackers.Count));
        }
        public void AutoMoveDefender()
        {// zieht die verteidiger
            if (0 == Defenders.Count)
                return;
            int i, j = 0, dist, bestdist = 0;
            BestTargetScore = 0.0f;
            for (i = 0; i < BattleMan.Battlefield.Count; i++)
            {// alle sektoren prüfen ob sich einheit dahin bewegen kann (frei + in reichweite) wenn was dazwischen ist stört nicht
                if ((BattleMan.Battlefield[i].Unit == null) || (BattleMan.Battlefield[i].Unit == Defenders[ActDefender]))
                {
                    for (j = 0; j < Attackers.Count; j++)
                    {// für die aktuelle verteidigereinheit jedes ziel durchgehen und score berechnen
                        dist = BattleMan.GetSectorDistance(BattleMan.Battlefield[i], BattleMan.Battlefield[Defenders[ActDefender].Battlesec]);
                        ActTargetScore = GetTargetScore(Defenders[ActDefender], Attackers[j], dist);
                        if (ActTargetScore > BestTargetScore)
                        {
                            BestTargetScore = ActTargetScore;
                            BestTargetIndex = j;
                            BestSectorIndex = i;
                            bestdist = dist;
                        }
                    }
                }
            }
            BattleMan.Battlefield[Defenders[ActDefender].Battlesec].Unit = null;    // zum optimalen sector bewegen und auf optimales ziel schießen
            BattleMan.Battlefield[BestSectorIndex].Unit = Defenders[ActDefender];
            Defenders[ActDefender].Battlesec = BestSectorIndex;
            Defenders[ActDefender].AttackUnit(Attackers[BestTargetIndex], bestdist);
            if (Attackers[BestTargetIndex].Hitpoints < 0.0f)
            {// ziel wurde zerstört also löschen und erfahrung geben
//                BattleSector.Attackers.Remove(Attackers[BestTargetIndex]);
                Gamedat.Players[AttackerIndex].Units.Units.Remove(Attackers[BestTargetIndex]);
                Attackers.RemoveAt(BestTargetIndex);
                Defenders[ActDefender].Experience *= 1.05f;
            }
            if (++ActDefender >= Defenders.Count)
                ActDefender = 0;    // von vorn beginnen
        }
        public void AutoMoveAttacker()
        {// zieht die angreifer
            if (0 == Attackers.Count)
                return;
            int i, j = 0, dist, bestdist = 0;
            BestTargetScore = 0.0f;
            for (i = 0; i < BattleMan.Battlefield.Count; i++)
            {// alle sektoren prüfen ob sich einheit dahin bewegen kann (frei + in reichweite) wenn was dazwischen ist stört nicht
                if ((BattleMan.Battlefield[i].Unit == null) || (BattleMan.Battlefield[i].Unit == Attackers[ActAttacker]))
                {
                    for (j = 0; j < Defenders.Count; j++)
                    {// für die aktuelle verteidigereinheit jedes ziel durchgehen und score berechnen
                        dist = BattleMan.GetSectorDistance(BattleMan.Battlefield[i], BattleMan.Battlefield[Attackers[ActAttacker].Battlesec]);
                        ActTargetScore = GetTargetScore(Attackers[ActAttacker], Defenders[j], dist );
                        if (ActTargetScore > BestTargetScore)
                        {
                            BestTargetScore = ActTargetScore;
                            BestTargetIndex = j;
                            BestSectorIndex = i;
                            bestdist = dist;
                        }
                    }
                }
            }
            BattleMan.Battlefield[Attackers[ActAttacker].Battlesec].Unit = null;    // zum optimalen sector bewegen und auf optimales ziel schießen
            BattleMan.Battlefield[BestSectorIndex].Unit = Attackers[ActAttacker];
            Attackers[ActAttacker].Battlesec = BestSectorIndex;
            Attackers[ActAttacker].AttackUnit(Defenders[BestTargetIndex], bestdist);
            if (Defenders[BestTargetIndex].Hitpoints < 0.0f)
            {// ziel wurde zerstört also löschen und erfahrung geben
//                BattleSector.Units.Remove(Defenders[BestTargetIndex]);
                Gamedat.Players[AttackerIndex].Units.Units.Remove(Attackers[BestTargetIndex]);
                Defenders.RemoveAt(BestTargetIndex);
                Defenders[ActDefender].Experience *= 1.05f;
            }
            if (++ActAttacker >= Attackers.Count)
                ActAttacker = 0;    // von vorn beginnen
        }
        public float GetTargetScore(Unit shooter, Unit target, int distance)
        {// berechnet wie gut es ist das ziel zu treffen (ob überhaupt)
            float score = 0.0f;
            shooter.Damage = 1.0f;  //# hack
            if ((distance >= shooter.MinFireRange) && (distance <= shooter.MaxFireRange))
            {// ziel ist in reichweite also trefferchance + schaden prüfen und sehen ob die einheit dadurch ausgeschaltet werden könnte
//#                score = ((shooter.Attack * shooter.Experience) / (target.Defence * target.Experience)) * shooter.Damage;
                score = (shooter.Attack / target.Defence) * shooter.Damage;
                if (target.Hitpoints - score <= 0.0f)   // gute chance dass die einheit durch den schuss zerstört wird also dass bevorzugen damit sie weg ist und keine gefahr mehr ist
                    score *= 10.0f;
            }
            return score;
        }
        private BattleSector GetFreeDefenderFront()
        {// liefert den nächsten freien sektor an der verteidigerfront
            int i;
            for(i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[DefenderFrontSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[i];
        }
        private BattleSector GetFreeDefenderBack()
        {// liefert den nächsten freien sektor im verteidiger hinterland
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[DefenderBackSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[i];
        }
        private BattleSector GetFreeAttackerFront()
        {// liefert den nächsten freien sektor an der angreiferfront
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[AttackerFrontSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[i];
        }
        private BattleSector GetFreeAttackerBack()
        {// liefert den nächsten freien sektor im angreifer hinterland
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[AttackerBackSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[i];
        }
    }
}
