﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PlanetaryDomination
{
    public class BattleView : BaseView
    {
        public BattleAI Battle;
        public BattleManager BattleMan;

        public BattleView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman) : base(graphicsman, inputman, soundman, viewman)
        {// konstruktor
            Controls.Add(new Button(1000, 650, 220, 30, "Attack [a]", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Attackfunc;
            ((Button)(Controls[0])).Shortkey = Keys.A;
            Controls.Add(new Button(1000, 690, 220, 30, "Move [m]", Color.Azure, 4, Graphics, Input, Sound));   // #1
            ((Button)(Controls[1])).ButtFunc = Movefunc;
            ((Button)(Controls[1])).Shortkey = Keys.M;
            Controls.Add(new Button(1000, 730, 220, 30, "Skip [s]", Color.Azure, 4, Graphics, Input, Sound));   // #2
            ((Button)(Controls[2])).ButtFunc = Skipfunc;
            ((Button)(Controls[2])).Shortkey = Keys.S;
            Controls.Add(new Button(1000, 770, 220, 30, "Give Up [g]", Color.Azure, 4, Graphics, Input, Sound));   // #3
            ((Button)(Controls[3])).ButtFunc = GiveUpfunc;
            ((Button)(Controls[3])).Shortkey = Keys.G;
            Controls.Add(new Button(1000, 810, 220, 30, "You Won/Lost [Enter]", Color.Azure, 4, Graphics, Input, Sound));   // #4
            ((Button)(Controls[4])).ButtFunc = NextTurnFunc;
            ((Button)(Controls[4])).Shortkey = Keys.G;
        }
        override public void Draw()
        {// rendert alles
            BattleMan.Draw();
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände und berechnet zb physik + effekte
            BattleMan.Update();
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
        }
        public void Init(BattleAI battle)
        {// initialisiert das kampffenster mit den übergebenen einheiten usw
            Battle = battle;
        }
        public void NextTurnFunc()
        {
            if (Battle.BattleOver())
            {// prüfen ob kampf zu ende
/*                if((Battle.DefenderIndex == Battle.Gamedat.HumanPlayer) && ())
                ((Button)(Controls[4])).Text = "You Won";*/
            }
            //am ende vom kampf auch beim battlemanager die einheiten aus sectoliste wieder entfernen und wenn sie im kampf sterben auch beim spieler entfernen,
            // ende bedingung also gewonnen oder verloren,
            // den button next turn nennen und wenn gewonnen oder verloren das schreiben und beim nächsten klick wird kampffenster wieder geschlossen,
        }
        public void Attackfunc()
        {
            BattleMan.Attackmode = true;
        }
        public void Movefunc()
        {
            BattleMan.Movemode = true;
        }
        public void Skipfunc()
        {
        }
        public void GiveUpfunc()
        {
        }
    }
}
