﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlanetaryDomination
{
    [Serializable()]
    public class Building
    {
        public String BuildName;    // name des Gebäudes
        public float BuildPercent;  // so viele prozent sind fertig gebaut
        public int BuildTurns, Level, ActBuildTurns;  // so viele Runden muss noch dran gebaut werden

        public Building(String name)
        {
            BuildName = name;
            Level = 0;
            ActBuildTurns = BuildTurns = 1; // für das erste Level eine runde dran bauen
            BuildPercent = 0.0f;
        }
        public bool BuildTurn()
        {// dieses Gebäude wird eine Runde gebaut
            bool retval = false;
            --ActBuildTurns;
            if(BuildTurns > ActBuildTurns)
                BuildPercent = 100.0f * ((float)(BuildTurns - ActBuildTurns) / (float)BuildTurns);
            if (0 == ActBuildTurns)
            {// gebäude ist fertig also level erhöhen und werte für nächsten level berechnen
                ++Level;
                ActBuildTurns = BuildTurns = GetBuildTime(Level + 1);
                BuildPercent = 0.0f;
                retval = true;
            }
            return retval;
        }
        public int GetBuildTime(int level)
        {// berechnet wie lange es dauert um ein gebäude auf dieses level zu bauen (vom vorhergehenden)
            return (int)Math.Pow(2.0, (double)(level - 1));
        }
    }
}
