﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public class Button : Control
    {// reagiert auf mausklicks und/oder shortkeys und führt funktionen aus
        public delegate void ButtonFunction();
        public ButtonFunction ButtFunc;
        public Keys Shortkey;

        public Button(int x, int y, int width, int height, String text, Color tcol, int tfont, GraphicsManager graphman, InputManager inputman, SoundManager soundman)
            : base(x, y, width, height, text, tcol, tfont, graphman, inputman, soundman)
        {// konstructor setzt buttonwerte, einige sind standardbelegt und müssen falls anders benötigt manuell gesetzt werden
            Graphics.GetStringSize(Text, Size, ref Stringsize, ref TextFont);
            TextOffset.X = (Size.X - Stringsize.X) * 0.5f;
            TextOffset.Y = (Size.Y - Stringsize.Y) * 0.5f;
        }
        override public void Draw()
        {
            if (!Active)    // nur wenn aktiv eingaben verarbeiten
                return;
            if (Highlighted)
                Graphics.DrawImagePart(X, Y, Width, Height, 0, 0, 32, 32, 6, 0.0f); // highlighted zeichnen
            else
                Graphics.DrawImagePart(X, Y, Width, Height, 0, 0, 32, 32, 5, 0.0f); // normalen background zeichnen
            Graphics.DrawText(Text,Position + TextOffset , TextColor, TextFont);
        }
        override public void Update()
        {
            if (!Active)    // nur wenn aktiv eingaben verarbeiten
                return;
            int mx = Input.GetMousePosX();
            int my = Input.GetMousePosY();
            bool lmc = Input.IsFirstPressed(0);
            if (PointInElement(mx, my))
            {// maus ist innerhalb des steuerelementrechtecks
                Highlighted = true;
                if (Input.IsFirstPressed(0))
                {
                    ButtFunc(); // klickfunktion ausführen
                    Sound.PlaySound(4);
                }
            }
            else
            {// maus ist außerhalb also zurücksetzen
                Highlighted = Prevhighlighted = false;
            }
            if (Highlighted != Prevhighlighted)
            {//# sound spielen
                Prevhighlighted = Highlighted;
                Sound.PlaySound(0);
            }
            if (Input.IsFirstPressed(Shortkey))
            {// auf shortkey testen
                ButtFunc(); // klickfunktion ausführen
                Sound.PlaySound(4);
            }
        }
    }
}
