﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public abstract class Control
    {
        public int X, Y, Width, Height, HighlightTexture, BackgroundTexture,TextFont;
        public GraphicsManager Graphics;
        public InputManager Input;
        public SoundManager Sound;
        public Color TextColor;
        public Vector2 Position, TextOffset, Stringsize, Size;
        public String Text;
        public bool Clickable, Highlighted, Prevhighlighted, Active;

        public Control(int x, int y, int width, int height, String text, Color bcol, int bfont, GraphicsManager graphman, InputManager inputman, SoundManager soundman)
        {// Konstructor
            Graphics = graphman;
            Input = inputman;
            Sound = soundman;
            X = x;
            Y = y;
            Width = width;
            Height = height;
            Position = new Vector2((float)X, (float)Y);
            Size = new Vector2((float)Width, (float)Height);
            TextOffset = new Vector2();
            Text = text;
            TextColor = bcol;
            TextFont = bfont;
            HighlightTexture = 6;
            BackgroundTexture = 5;
            Clickable = Active = true;
            Highlighted = Prevhighlighted = false;
        }
        public bool PointInElement(int mousex, int mousey)
        {// checks if the given point lies within the borders of the actual element
            return ((mousex >= X) && (mousex <= X + Width) && (mousey >= Y) && (mousey <= Y + Height));
        }
        public abstract void Draw();
        public abstract void Update();
    }
}
