﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PlanetaryDomination
{
    public class CreateGameView : BaseView
    {
        private int NumberofPlayers, ActPlayer, NumberofSectors;
        public GameData Gamedata;

        public CreateGameView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman)
            : base(graphicsman, inputman, soundman, viewman)
        {// konstruktor
            NumberofPlayers = 3;
            ActPlayer = 0;
            NumberofSectors = 5;
            Controls.Add(new Button(1060, 910, 180, 30, "Start Game", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Startfunc;
            Controls.Add(new Editfield(50, 240, 180, 30, "", "Your Name", Color.White, 4, Graphics, Input, Sound));   // #1

            Controls.Add(new Button(300, 475, 80, 30, "<-", Color.Azure, 4, Graphics, Input, Sound));   // #2
            ((Button)(Controls[2])).ButtFunc = PrevCol;
            Controls.Add(new Button(500, 475, 80, 30, "->", Color.Azure, 4, Graphics, Input, Sound));   // #3
            ((Button)(Controls[3])).ButtFunc = NextCol;


            Controls.Add(new Button(300, 355, 80, 30, "-1", Color.Azure, 4, Graphics, Input, Sound));   // #4
            ((Button)(Controls[4])).ButtFunc = RemovePlayer;
            Controls.Add(new Button(500, 355, 80, 30, "+1", Color.Azure, 4, Graphics, Input, Sound));   // #5
            ((Button)(Controls[5])).ButtFunc = AddPlayer;

            Controls.Add(new Button(300, 115, 80, 30, "-1", Color.Azure, 4, Graphics, Input, Sound));   // #6
            ((Button)(Controls[6])).ButtFunc = RemoveSector;
            Controls.Add(new Button(500, 115, 80, 30, "+1", Color.Azure, 4, Graphics, Input, Sound));   // #7
            ((Button)(Controls[7])).ButtFunc = AddSector;
        }
        override public void Draw()
        {// rendert alles
            tempvect.X = 510.0f;// hier selber die gui malen
            tempvect.Y = 50.0f;
            Graphics.DrawText("Customize your Game", tempvect, Color.White, 5);
            tempvect.X = 50.0f;
            tempvect.Y = 480.0f;
            Graphics.DrawText("Choose your Color:", tempvect, Color.White, 5);
            tempvect.X = 400.0f;
            tempvect.Y = 480.0f;
            Graphics.DrawText(Gamedata.Players[ActPlayer].Playername, tempvect, Gamedata.Players[ActPlayer].Playercolor, 5);

            tempvect.X = 50.0f;
            tempvect.Y = 360.0f;
            Graphics.DrawText("Number of Players:", tempvect, Color.White, 5);
            tempvect.X = 410.0f;
            tempvect.Y = 360.0f;
            Graphics.DrawText(String.Format("{0}", NumberofPlayers), tempvect, Color.White, 5);

            tempvect.X = 50.0f;
            tempvect.Y = 120.0f;
            Graphics.DrawText("Number of Sectors:", tempvect, Color.White, 5);
            tempvect.X = 410.0f;
            tempvect.Y = 120.0f;
            Graphics.DrawText(String.Format("{0}", NumberofSectors), tempvect, Color.White, 5);
            tempvect.X = 600.0f;
            tempvect.Y = 120.0f;
            Graphics.DrawText(String.Format("x {0} = {1}", NumberofSectors * 2, NumberofSectors * NumberofSectors * 2), tempvect, Color.White, 5);
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände und berechnet zb physik + effekte
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
        }
        private void Startfunc()
        {//ausführen für button start
            Gamedata.Sectors.CreateSectors(NumberofSectors * NumberofSectors * 2, NumberofPlayers, ActPlayer);
            Gamedata.HumanPlayer = ActPlayer;
            if(Controls[1].Text.Length > 0)
                Gamedata.Players[ActPlayer].Playername = Controls[1].Text;  // farbnamen mit namen des spielers überschreiben falls er einen eingegeben hat sonst bleibt es
            Views.SwitchView(1);
        }
        private void PrevCol()
        {// vorherige farbe zeigen
            if (--ActPlayer < 0)
                ActPlayer = NumberofPlayers - 1;
        }
        private void NextCol()
        {// nächste farbe zeigen
            if (++ActPlayer > NumberofPlayers - 1)
                ActPlayer = 0;
        }
        private void AddPlayer()
        {// spieler hinzufügen
            if (NumberofPlayers < 8)
                ++NumberofPlayers;
        }
        private void RemovePlayer()
        {// spieler entfernen
            if (NumberofPlayers > 2)
                --NumberofPlayers;
        }
        private void AddSector()
        {// sector hinzufügen
            if (NumberofSectors < 20)
                ++NumberofSectors;
        }
        private void RemoveSector()
        {// sector entfernen
            if (NumberofSectors > 3)
                --NumberofSectors;
        }
    }
}
