﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public class Editfield : Control
    {
        public String Title;
        public Vector2 Titlesize, YOffset, XOffset;
        public StringBuilder EditText;
        int MaxLength;

        public Editfield(int x, int y, int width, int height, String text, String title, Color tcol, int tfont, GraphicsManager graphman, InputManager inputman, SoundManager soundman)
            : base(x, y, width, height, text, tcol, tfont, graphman, inputman, soundman)
        {// konstructor setzt editwerte, einige sind standardbelegt und müssen falls anders benötigt manuell gesetzt werden
            Title = title;
            EditText = new StringBuilder(10);
            Graphics.GetStringSize("A", Size,ref Stringsize, ref TextFont); // abmessungen eines zeichens bestimmen
            Graphics.GetStringSize(Title, TextFont, ref Titlesize); // abmessungen eines zeichens bestimmen
            Titlesize.Y = 0.0f; // zurücksetzen da schrift nicht nach unten sondern nur nach rechts versetzt werden soll
            TextOffset.X = 4.0f;
            TextOffset.Y = 4.0f;
            YOffset = new Vector2(0.0f, TextOffset.Y);
            XOffset = new Vector2(TextOffset.X, 0.0f);
            MaxLength = (int)Math.Floor((double)(Size.X / Stringsize.X))-1;
        }
        override public void Draw()
        {
            Graphics.DrawText(Title, Position + YOffset, TextColor, TextFont);    // titel schreiben
            Graphics.DrawImagePart(X+(int)(Titlesize.X + XOffset.X), Y, Width, Height, 0, 0, 32, 32, 5, 0.0f); // normalen background zeichnen
            Graphics.DrawText(Text, Position + TextOffset + XOffset + Titlesize, TextColor, TextFont);
            if (Highlighted)    // element hat focus also cursor zeichnen
                Graphics.DrawImagePart(X + Text.Length * (int)Stringsize.X + (int)(Titlesize.X + XOffset.X * 2.0f), Y, (int)Stringsize.X, (int)Stringsize.Y, 0, 0, 32, 32, 6, 0.0f); // highlighted zeichnen
        }
        override public void Update()
        {
            int mx = Input.GetMousePosX();
            int my = Input.GetMousePosY();
            bool lmc = Input.IsFirstPressed(0);
            if ((PointInElement(mx - (int)(Titlesize.X + TextOffset.X), my)) && (lmc))
            {// maus ist innerhalb des steuerelementrechtecks
                Highlighted = true;
            }
            else if ((!PointInElement(mx - (int)(Titlesize.X+TextOffset.X), my)) && (lmc))
            {// maus ist außerhalb also zurücksetzen
                Highlighted = Prevhighlighted = false;
            }
            if (Highlighted)
            {// wenn focus eingaben verarbeiten
                List<Keys> newkeys = Input.GetNewPressedKeys();
                int keyint;
                foreach (Keys key in newkeys)
                {
                    keyint = (int)key;
                    if (8 == keyint)
                    {// backspace
                        EditText.Remove(EditText.Length - 1, 1);
                    }
                    if (EditText.Length < MaxLength)
                    {// nur wenn noch platz in feld ist zeichen aufnehmen (nicht scrollbar)
                        if (((keyint > 64) && (keyint < 91)) && (Input.IsPressed(Keys.LeftShift) || Input.IsPressed(Keys.RightShift)))
                        {// ein großbuchstabe
                            EditText.Append((char)(int)key);
                        }
                        else if (((keyint > 64) && (keyint < 91)) && (!Input.IsPressed(Keys.LeftShift) && !Input.IsPressed(Keys.RightShift)))
                        {// ein kleinbuchstabe
                            EditText.Append((char)(int)(key + 32));
                        }
                        if (((keyint > 47) && (keyint < 58)) || (32 == keyint))
                        {// ziffer + space
                            EditText.Append((char)(int)key);
                        }
                    }
                    else
                    {// wenn voll und taste gedrückt sound spielen //# das bezieht sich jetzt auch auf shift usw
//# das nach einfügen frei schalten                        Sound.PlaySound(5);
                    }
                }
                Text = EditText.ToString();
            }
        }
    }
}
