﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PlanetaryDomination
{
    public class MapView : BaseView
    {// die kartenansicht zeigt 3d sichten der galaxis (sterne, sprungtore) und bietet navigation
        public SectorManager Sectors;
        public GameData Gamedata;
        public int ActionState, UnitScrollLvl, ActiveUnitID, LastSelectSector;

        public MapView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman)
            : base(graphicsman, inputman, soundman, viewman)
        {// konstruktor
            Controls.Add(new Button(1055, 920, 220, 30, "Next Turn [Enter]", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Nextfunc;
            ((Button)(Controls[0])).Shortkey = Keys.Enter;
            Controls.Add(new Button(1055, 850, 220, 30, "Research [r]", Color.Azure, 4, Graphics, Input, Sound));   // #1
            ((Button)(Controls[1])).ButtFunc = Researchfunc;
            ((Button)(Controls[1])).Shortkey = Keys.R;
            Controls.Add(new Button(480, 850, 100, 20, "Build", Color.Azure, 4, Graphics, Input, Sound));   // #2
            ((Button)(Controls[2])).ButtFunc = BuildBuildingFunc;
            ((Button)(Controls[2])).TextFont = 4;
            ((Button)(Controls[2])).TextOffset.X -= 10.0f;
            Controls.Add(new Button(480, 875, 100, 20, "Build", Color.Azure, 4, Graphics, Input, Sound));   // #3
            ((Button)(Controls[3])).ButtFunc = BuildUnitFunc;
            ((Button)(Controls[3])).TextFont = 4;
            ((Button)(Controls[3])).TextOffset.X -= 10.0f;
            Controls.Add(new Button(480, 900, 100, 20, "Select", Color.Azure, 4, Graphics, Input, Sound));   // #4
            ((Button)(Controls[4])).ButtFunc = SelectUnitFunc;
            ((Button)(Controls[4])).TextFont = 4;
            ((Button)(Controls[4])).TextOffset.X -= 10.0f;

            Controls.Add(new Button(650, 645, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #5
            ((Button)(Controls[5])).ButtFunc = ListClickFunc1;
            ((Button)(Controls[5])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 680, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #6
            ((Button)(Controls[6])).TextOffset.X = 10.0f;
            ((Button)(Controls[6])).ButtFunc = ListClickFunc2;
            Controls.Add(new Button(650, 715, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #7
            ((Button)(Controls[7])).ButtFunc = ListClickFunc3;
            ((Button)(Controls[7])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 750, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #8
            ((Button)(Controls[8])).ButtFunc = ListClickFunc4;
            ((Button)(Controls[8])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 785, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #9
            ((Button)(Controls[9])).ButtFunc = ListClickFunc5;
            ((Button)(Controls[9])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 820, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #10
            ((Button)(Controls[10])).ButtFunc = ListClickFunc6;
            ((Button)(Controls[10])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 855, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #11
            ((Button)(Controls[11])).ButtFunc = ListClickFunc7;
            ((Button)(Controls[11])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 890, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #12
            ((Button)(Controls[12])).ButtFunc = ListClickFunc8;
            ((Button)(Controls[12])).TextOffset.X = 10.0f;
            Controls.Add(new Button(650, 925, 380, 30, "test", Color.Azure, 4, Graphics, Input, Sound));   // #13
            ((Button)(Controls[13])).ButtFunc = ListClickFunc9;
            ((Button)(Controls[13])).TextOffset.X = 10.0f;
            HideList();
            ActionState = 0;    // am anfang keine aktion gewählt
            UnitScrollLvl = -1;  // bestimmt wo in der einheitenliste (durch mehrfachklicken) hingescrollt wird
        }
        override public void Draw()
        {// rendert alles
            Sectors.Draw(); // zeichnet das spielfeld
            tempvect.X = 1100.0f;
            tempvect.Y = 890.0f;
            Graphics.DrawText(String.Format("Turn: {0}", Gamedata.Turn), tempvect, Color.White, 5);
            Sector tempsect = Sectors.GetActSector();
            tempvect.X = 1050.0f;
            tempvect.Y = 650.0f;
            Graphics.DrawText(String.Format("Sectors :{0}", Gamedata.Players[Gamedata.HumanPlayer].OwnSectors.Count), tempvect, Color.White, 4);
            tempvect.X = 1050.0f;
            tempvect.Y = 680.0f;
            Graphics.DrawText(String.Format("Units   :{0}", Gamedata.Players[Gamedata.HumanPlayer].Units.Units.Count), tempvect, Color.White, 4);
            tempvect.X = 1050.0f;
            tempvect.Y = 710.0f;
            Graphics.DrawText(String.Format("Minerals:{0}/+{1}pt", Gamedata.Players[Gamedata.HumanPlayer].TotMinerals, Gamedata.Players[Gamedata.HumanPlayer].RoundMins), tempvect, Color.White, 4);
            tempvect.X = 1050.0f;
            tempvect.Y = 740.0f;
            Graphics.DrawText(String.Format("LifeSupp:{0}/+{1}pt", Gamedata.Players[Gamedata.HumanPlayer].TotOrganics, Gamedata.Players[Gamedata.HumanPlayer].RoundLifeSupport), tempvect, Color.White, 4);
            tempvect.X = 1050.0f;
            tempvect.Y = 770.0f;
            Graphics.DrawText(String.Format("Energy  :{0}/+{1}pt", Gamedata.Players[Gamedata.HumanPlayer].TotEnergy, Gamedata.Players[Gamedata.HumanPlayer].RoundEnergy), tempvect, Color.White, 4);
            tempvect.X = 1050.0f;
            tempvect.Y = 800.0f;
            Graphics.DrawText(String.Format("Techpts :{0}/+{1}pt", Gamedata.Players[Gamedata.HumanPlayer].TotResearch, Gamedata.Players[Gamedata.HumanPlayer].RoundTechPoints), tempvect, Color.White, 4);
            if (tempsect.Examined[Gamedata.HumanPlayer])
            {// der sektor wurde vom spieler untersucht, also infos zu resourcen anzeigen
                tempvect.X = 10.0f;
                tempvect.Y = 700.0f;
                Graphics.DrawText(String.Format("Resources  : Ore:{0} Anorganics:{1} Energy:{2}", tempsect.Ore, tempsect.Anorganics, tempsect.Energy), tempvect, Color.White, 4);
            }
            if (tempsect.Owner == Gamedata.HumanPlayer)
            {// nur wenn der sektor dem spieler gehört die kontrolle erlauben und infos usw anzeigen
                tempvect.X = 10.0f;
                tempvect.Y = 725.0f;
                Graphics.DrawText(String.Format("Buildings  : Mine:{0}/{3} Greenhouse:{1}/{3} Powerplant:{2}/{3}", tempsect.Buildings[0].Level, tempsect.Buildings[1].Level, tempsect.Buildings[2].Level, Gamedata.MaxBuildingLevel), tempvect, Color.White, 4);
                tempvect.X = 10.0f;
                tempvect.Y = 750.0f;
                Graphics.DrawText(String.Format("           : Factory:{0}/{3} Barracks:{1}/{3} Academy:{2}/{3}", tempsect.Buildings[3].Level, tempsect.Buildings[4].Level, tempsect.Buildings[5].Level, Gamedata.MaxBuildingLevel), tempvect, Color.White, 4);
                tempvect.X = 10.0f;
                tempvect.Y = 775.0f;
                Graphics.DrawText(String.Format("           : Scanner:{0}/{2} Transport:{1}/{2}", tempsect.Buildings[6].Level, tempsect.Buildings[7].Level, Gamedata.MaxBuildingLevel), tempvect, Color.White, 4);
                int prospcnt, basecnt, defcnt, articnt, infcnt, vehiccnt, avehiccnt, tankcnt, i, transit = 0;
                prospcnt = basecnt = defcnt = articnt = infcnt = vehiccnt = avehiccnt = tankcnt = 0;
                for (i = 0; i < tempsect.Units.Count; i++)
                {// die einheiten durchgehen und typen zusammenzählen, 0-Prospector,1-Basemodule,2-Infantery,3-Vehicle,4-ArmedVehicle,5-Tank,6-Artillery,7-Building
                    if (tempsect.Units[i].Type == 0)
                        ++prospcnt;
                    if (tempsect.Units[i].Type == 1)
                        ++basecnt;
                    if (tempsect.Units[i].Type == 2)
                        ++infcnt;
                    if (tempsect.Units[i].Type == 3)
                        ++vehiccnt;
                    if (tempsect.Units[i].Type == 4)
                        ++avehiccnt;
                    if (tempsect.Units[i].Type == 5)
                        ++tankcnt;
                    if (tempsect.Units[i].Type == 6)
                        ++articnt;
                    if (tempsect.Units[i].Type == 7)
                        ++defcnt;
                    if (tempsect.Units[i].ETA > 0)
                        ++transit;
                }
                tempvect.X = 10.0f;
                tempvect.Y = 800.0f;
                Graphics.DrawText(String.Format("Units {0}+{6}/{5}: Prosp:{1} Base:{2} Defense:{3} Arti:{4}", tempsect.Units.Count, prospcnt, basecnt, defcnt, articnt, 4 + tempsect.Buildings[4].Level, transit), tempvect, Color.White, 4);
                tempvect.X = 10.0f;
                tempvect.Y = 825.0f;
                Graphics.DrawText(String.Format("           : Inf:{0} Vehicle:{1} ArmVeh:{2} Tank:{3}", infcnt, vehiccnt, avehiccnt, tankcnt), tempvect, Color.White, 4);


                tempvect.X = 10.0f;
                tempvect.Y = 850.0f;
                if (-1 != tempsect.BuildBuilding)
                    Graphics.DrawText(String.Format("Building   : {0} {1}% {2}Turns", tempsect.Buildings[tempsect.BuildBuilding].BuildName, tempsect.Buildings[tempsect.BuildBuilding].BuildPercent, tempsect.Buildings[tempsect.BuildBuilding].ActBuildTurns), tempvect, Color.White, 4);
                else
                    Graphics.DrawText("Building   : None", tempvect, Color.Red, 4);
                tempvect.X = 10.0f;
                tempvect.Y = 875.0f;
                List<Unit> techlist = Gamedata.Players[tempsect.Owner].Units.Technologies;
                if (-1 != tempsect.BuildUnitID)
                    Graphics.DrawText(String.Format("Unit       : {0} {1}% {2}Turns", techlist[tempsect.BuildUnitID].Name, 100.0f * (float)tempsect.UnitBuildCost / (float)techlist[tempsect.BuildUnitID].ProductionCost, Math.Ceiling((double)(techlist[tempsect.BuildUnitID].ProductionCost - tempsect.UnitBuildCost) / (double)tempsect.Buildings[3].Level)), tempvect, Color.White, 4);
                else
                    Graphics.DrawText("Unit       : None", tempvect, Color.Red, 4);
            }
            else if (tempsect.Owner == 8)
            {// sektor gehört niemandem aber einheiten können dort trotzdem stationiert sein
                if (tempsect.Units.Count > 0)
                {
                    if (tempsect.Units[0].Owner == Gamedata.HumanPlayer)
                    {// einheiten gehören dem spieler, jeder sektor kann nur einheiten eines spielers enthalten da es sonst zu kampf kommt bis alle einheiten eines spielers zerstört sind
                        int prospcnt, basecnt, defcnt, articnt, infcnt, vehiccnt, avehiccnt, tankcnt, i, transit = 0;
                        prospcnt = basecnt = defcnt = articnt = infcnt = vehiccnt = avehiccnt = tankcnt = 0;
                        for (i = 0; i < tempsect.Units.Count; i++)
                        {// die einheiten durchgehen und typen zusammenzählen, 0-Prospector,1-Basemodule,2-Infantery,3-Vehicle,4-ArmedVehicle,5-Tank,6-Artillery,7-Building
                            if (tempsect.Units[i].Type == 0)
                                ++prospcnt;
                            if (tempsect.Units[i].Type == 1)
                                ++basecnt;
                            if (tempsect.Units[i].Type == 2)
                                ++infcnt;
                            if (tempsect.Units[i].Type == 3)
                                ++vehiccnt;
                            if (tempsect.Units[i].Type == 4)
                                ++avehiccnt;
                            if (tempsect.Units[i].Type == 5)
                                ++tankcnt;
                            if (tempsect.Units[i].Type == 6)
                                ++articnt;
                            if (tempsect.Units[i].Type == 7)
                                ++defcnt;
                            if (tempsect.Units[i].ETA > 0)
                                ++transit;
                        }
                        tempvect.X = 10.0f;
                        tempvect.Y = 800.0f;
//                        Graphics.DrawText(String.Format("Units {0}+{6}/{5}: Prosp:{1} Base:{2} Defense:{3} Arti:{4}", tempsect.Units.Count - transit, prospcnt, basecnt, defcnt, articnt, 4 + tempsect.Buildings[4].Level, transit), tempvect, Color.White, 4);
                        tempvect.X = 10.0f;
                        tempvect.Y = 825.0f;
                        Graphics.DrawText(String.Format("           : Inf:{0} Vehicle:{1} ArmVeh:{2} Tank:{3}", infcnt, vehiccnt, avehiccnt, tankcnt), tempvect, Color.White, 4);
                    }
                    else
                    {// einheiten gehören anderem spieler also nur anzahl in der spielerfarbe anzeigen (ohne typauflistung)
                        tempvect.X = 10.0f;
                        tempvect.Y = 800.0f;
                        Graphics.DrawText(String.Format("Units {0}        :", tempsect.Units.Count), tempvect, Gamedata.Players[tempsect.Units[0].Owner].Playercolor, 4);
                    }
                }
            }
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände
            LastSelectSector = Sectors.ActSelSector;
            Sectors.Update();
            if (Sectors.ActSelSector != LastSelectSector)
            {
                ActionState = 0;
                HideList();
            }
            Sector tempsect = Sectors.GetActSector();
            DeactivateButtons();    // alle buttons deaktivieren da man in systemen die einem nicht gehören nichts bauen usw kann
            if (tempsect.Owner == Gamedata.HumanPlayer)
            {// nur wenn der sektor dem spieler gehört die buttons anzeigen und updaten
                Controls[2].Active = true;
                if(tempsect.Buildings[3].Level > 0) // einheiten bauen nur anzeigen wenn fabrik mind. 1 level hat
                   Controls[3].Active = true;
                if(tempsect.Units.Count > 0)
                   Controls[4].Active = true;
            }
            else if ((tempsect.Owner == 8) && (tempsect.Units.Count > 0) && (tempsect.Units[0].Owner == Gamedata.HumanPlayer))
            {// eigene einheiten vorhanden also auswählen lassen
                Controls[4].Active = true;
            }
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
            if ((Input.IsFirstPressed(Keys.Q)) && (0 != ActionState))
            {// benutzer hat eine aktion gestartet und möchte abbrechen
                ActionState = 0;
                HideList();
            }
        }
        private void Nextfunc()
        {//ausführen für button next turn
            Gamedata.NextTurn();
            Gamedata.SaveGame("\\Autosave.sav");    // spiel automatisch jede runde speichern
            ActionState = 0;
            HideList();
            int i;
            List<Sector> sectors = Gamedata.Sectors.SectorList;
            if (0 == Gamedata.Players[Gamedata.HumanPlayer].OwnSectors.Count)
            {// spieler hat verloren
                Views.SwitchView(3);
                //# hier noch einen text setzen dass verloren
                return;
            }
            bool won = true;
            for (i = 0; i < Gamedata.Players.Count; i++)
            {
                if ((i != Gamedata.HumanPlayer) && (0 < Gamedata.Players[i].OwnSectors.Count))
                {// der spieler hat noch welche also nicht gewonnen
                    won = false;
                }   
            }
            if(won)
            {// keine gegner mehr da
                Views.SwitchView(3);
                //# hier noch einen text setzen dass gewonnen
            }
        }
        private void ActivateButtons()
        {// die buttons für die sektorsteuerung aktivieren
            Controls[2].Active = true;
            Controls[3].Active = true;
            Controls[4].Active = true;
        }
        private void DeactivateButtons()
        {// die buttons für die sektorsteuerung aktivieren
            Controls[2].Active = false;
            Controls[3].Active = false;
            Controls[4].Active = false;
        }
        private void ShowList()
        {// die buttons für die sektorsteuerung aktivieren
            Controls[5].Active = true;
            Controls[6].Active = true;
            Controls[7].Active = true;
            Controls[8].Active = true;
            Controls[9].Active = true;
            Controls[10].Active = true;
            Controls[11].Active = true;
            Controls[12].Active = true;
            Controls[13].Active = true;
        }
        private void HideList()
        {// die buttons für die sektorsteuerung aktivieren
            Controls[5].Active = false;
            Controls[6].Active = false;
            Controls[7].Active = false;
            Controls[8].Active = false;
            Controls[9].Active = false;
            Controls[10].Active = false;
            Controls[11].Active = false;
            Controls[12].Active = false;
            Controls[13].Active = false;
        }
        private void Researchfunc()
        {// zeigt das forschungsfenster an
            Views.SwitchView(5);
        }
        private void BuildBuildingFunc()
        {// lässt ein gebäude zum bauen auswählen
            Sector tempsect = Sectors.GetActSector();
            HideList(); // alles verstecken und nur die gültigen anzeigen
            for (int i = 0; i < tempsect.Buildings.Count; i++)
            {// die buttons beschriften mit den aktuellen daten
                ((Button)(Controls[i+5])).Text = String.Format("{0} Lvl {1} in {2} Turns", tempsect.Buildings[i].BuildName, tempsect.Buildings[i].Level + 1, tempsect.Buildings[i].ActBuildTurns);
                if (tempsect.Buildings[i].Level <= Gamedata.MaxBuildingLevel)   // nur wenn gebäude noch weiter gebaut werden kann
                    ((Button)(Controls[i + 5])).Active = true;
            }
            ActionState = 1;
        }
        private void BuildUnitFunc()
        {// lässt eine einheit zum bauen auswählen (nur die anzeigen die mit resourcen und tech gebaut werden können)
            Sector tempsect = Sectors.GetActSector();
            if (tempsect.Units.Count == tempsect.Buildings[4].Level + 4)
            {// prüfen ob überhaupt platz ist in dem sektor
                return;
            }
            List<Unit> techlist = Gamedata.Sectors.CurrentBuildList;
            if(-1 == UnitScrollLvl)
            {// nach initialisierung oder auswahl einer einheit zum bauen also von vorn beginnen
                UnitScrollLvl = 0;
            }
            else
            {// erhöhen
                if(UnitScrollLvl + 1 >= (int)Math.Ceiling((double)Sectors.CurrentBuildList.Count / 9.0))
                {// ich hab übers ende gescrolled also von vorn beginnen
                    UnitScrollLvl = 0;
                }
                else
                {// sonst ganz normal weiterscrollen
                    ++UnitScrollLvl;
                }
            }
            if (-1 != tempsect.BuildUnitID)
            {// es wird schon eine einheit gebaut also zurücksetzen-> keine erstattung und kein später weiterbauen
                tempsect.UnitBuildCost = 0;
                tempsect.BuildUnitID = -1;
            }
            HideList(); // alles verstecken und nur die gültigen anzeigen
            for (int i = UnitScrollLvl * 9; i < Math.Min(techlist.Count, ((UnitScrollLvl+1) * 9)); i++)
            {// die buttons beschriften mit den aktuell verfügbaren einheiten
                ((Button)(Controls[i + 5])).Text = String.Format("{0} in {1} Turns", techlist[i].Name, Math.Ceiling((double)techlist[i].ProductionCost / (double)tempsect.Buildings[3].Level));
                ((Button)(Controls[i + 5])).Active = true;
            }
            ActionState = 2;
        }
        private void SelectUnitFunc()
        {// lässt eine einheit auswählen und damit befehle machen
            Sector tempsect = Sectors.GetActSector();
            List<Unit> sectorunitlist = tempsect.Units;
            HideList(); // alles verstecken und nur die gültigen anzeigen
            for (int i = 0; i < sectorunitlist.Count; i++)
            {// die buttons beschriften mit den einheiten im sektor
                if (0 == sectorunitlist[i].ETA)
                {// nur die einheiten die schon vorhanden sind anzeigen, die die noch in transit sind ignorieren
                    ((Button)(Controls[i + 5])).Text = String.Format("{0} in {1}/{2}HP", sectorunitlist[i].Name, sectorunitlist[i].Hitpoints, sectorunitlist[i].Maxhitpoints);
                    ((Button)(Controls[i + 5])).Active = true;
                }
            }
            ActionState = 3;
        }
        private void ListClickFunc1()
        {// click auf listeneintrag
            ExecuteListFunc(0);
        }
        private void ListClickFunc2()
        {// click auf listeneintrag
            ExecuteListFunc(1);
        }
        private void ListClickFunc3()
        {// click auf listeneintrag
            ExecuteListFunc(2);
        }
        private void ListClickFunc4()
        {// click auf listeneintrag
            ExecuteListFunc(3);
        }
        private void ListClickFunc5()
        {// click auf listeneintrag
            ExecuteListFunc(4);
        }
        private void ListClickFunc6()
        {// click auf listeneintrag
            ExecuteListFunc(5);
        }
        private void ListClickFunc7()
        {// click auf listeneintrag
            ExecuteListFunc(6);
        }
        private void ListClickFunc8()
        {// click auf listeneintrag
            ExecuteListFunc(7);
        }
        private void ListClickFunc9()
        {// click auf listeneintrag
            ExecuteListFunc(8);
        }
        private void ExecuteListFunc(int listbutton)
        {// führt die gewünschte aktion durch
            Unit tempunit;
            Sector tempsect = Sectors.GetActSector();
            float repairfrac;
            Player player;
            switch (ActionState)
            {
                case 1: // ein gebäude zum bauen wurde ausgewählt
                    tempsect.BuildBuilding = listbutton;
                    break;
                case 2: // eine einheit zum bauen wurde ausgewählt
                    tempunit = Sectors.CurrentBuildList[listbutton + UnitScrollLvl * 9];
                    tempsect.BuildUnitID = tempunit.Techlistindex;
                    Gamedata.Players[tempsect.Owner].TotMinerals -= tempunit.MinCost;
                    Gamedata.Players[tempsect.Owner].TotOrganics -= tempunit.OrgCost;
                    Gamedata.Players[tempsect.Owner].TotEnergy -= tempunit.EnergyCost;
                    UnitScrollLvl = -1; // das nächste mal von vorn beginnen beim scrollen
                    break;
                case 3: // eine einheit wurde ausgwählt also listbuttons mit befehlen bestücken
                    HideList();
                    tempunit = tempsect.Units[listbutton];
                    player = Gamedata.Players[Gamedata.HumanPlayer];
                    ActiveUnitID = listbutton;
                    if (tempunit.Speed > 0)
                    {// die einheit kann sich bewegen also button dafür anzeigen
                        ((Button)(Controls[5])).Text = "Move";
                        ((Button)(Controls[5])).Active = true;
                    }
                    if ((1 == tempunit.Type) && (8 == tempsect.Owner))
                    {// basismodul also in unbesidelten sektoren kolonie gründen
                        ((Button)(Controls[6])).Text = "Settle";
                        ((Button)(Controls[6])).Active = true;
                    }
                    if ((0 == tempunit.Type) && (false == tempsect.Examined[Gamedata.HumanPlayer]))
                    {// prospektor also in unerforschtem sektor erforschen
                        ((Button)(Controls[7])).Text = "Explore";
                        ((Button)(Controls[7])).Active = true;
                    }
                    if(tempunit.Hitpoints < tempunit.Maxhitpoints)
                    {// beschädigt
                        repairfrac = (tempunit.Maxhitpoints - tempunit.Hitpoints) / tempunit.Maxhitpoints;
                        if (((int)Math.Ceiling((float)tempunit.MinCost * repairfrac) <= player.TotMinerals) && ((int)Math.Ceiling((float)tempunit.OrgCost * repairfrac) <= player.TotOrganics) && ((int)Math.Ceiling((float)tempunit.EnergyCost * repairfrac) <= player.TotEnergy))
                        {// alle rohstoffe vorhanden also reparieren
                            ((Button)(Controls[8])).Text = "Repair";
                            ((Button)(Controls[8])).Active = true;
                        }
                    }
                    if (Sectors.NeighbourSectorAttackable() && (tempunit.Speed > 0))
                    {// nachbarsector mit feind + einheit kann sich bewegen
                        ((Button)(Controls[9])).Text = "Attack";
                        ((Button)(Controls[9])).Active = true;
                    }
                    ((Button)(Controls[10])).Text = "Show Info"; // infos anzeigen kann immer gemacht werden
                    ((Button)(Controls[10])).Active = true;
                    ((Button)(Controls[11])).Text = "Cancel"; // abbrechen wenn man keine aktion durchführen will
                    ((Button)(Controls[11])).Active = true;
                    ActionState = 4;    // noch die entsprechende fkt auswählen
                    break;
                case 4: // die aktion für die einheit wurde ausgewählt
                    switch (listbutton)
                    {
                        case 0: // move
                            Sectors.SetMoveMode(tempsect.Number, tempsect.Units[ActiveUnitID]);
                            //# muss die einheit ihren sektor kennen zb um schnell bewegt zu werden? auch für ki,
                            break;
                        case 1: // settle
                            tempsect.Owner = Gamedata.HumanPlayer;  // sektor in besitz nehmen
                            Gamedata.Players[Gamedata.HumanPlayer].Units.Units.Remove(tempsect.Units[ActiveUnitID]);    // beim spieler löschen
                            tempsect.Units.RemoveAt(ActiveUnitID);  // beim sector löschen
                            break;
                        case 2: // explore
                            tempsect.Examined[Gamedata.HumanPlayer] = true;
                            break;
                        case 3: // repair
                            tempunit = tempsect.Units[ActiveUnitID];
                            repairfrac = (tempunit.Maxhitpoints - tempunit.Hitpoints) / tempunit.Maxhitpoints;
                            tempunit.Hitpoints = tempunit.Maxhitpoints; // hp wieder zurücksetzen
                            Gamedata.Players[Gamedata.HumanPlayer].TotMinerals -= (int)Math.Ceiling(repairfrac * (double)tempunit.MinCost);
                            Gamedata.Players[Gamedata.HumanPlayer].TotOrganics -= (int)Math.Ceiling(repairfrac * (double)tempunit.OrgCost);
                            Gamedata.Players[Gamedata.HumanPlayer].TotEnergy -= (int)Math.Ceiling(repairfrac * (double)tempunit.EnergyCost);
                            break;
                        case 4: // attack
                            Sectors.SetAttackMode(tempsect.Number, tempsect.Units[ActiveUnitID]);
                            break;
                        case 5: // show info
                            break;
                        case 6: // cancel (nichts machen)
                            break;
                    }
                    ActionState = 0;
                    break;
            }
            if (ActionState < 4)
            {// wenn ich noch funktion für einheit auswähle alles so lassen sonst zurücksetzen da vorgang abgeschlossen
                ActionState = 0;
                HideList();
            }
        }
    }
}

