﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    [Serializable()]
    public class Player
    {
        public Color Playercolor;
        public String Playername;
        public UnitManager Units;
        public List<Sector> OwnSectors;
        public int RoundMins, RoundEnergy, RoundLifeSupport, RoundTechPoints, AttackSector, CollectSector;

        public int TotMinerals, TotOrganics, TotEnergy, TotResearch;

        public Player(String name, Color color)
        {
            Units = new UnitManager();
            Playercolor = color;
            Playername = name;
            TotMinerals = TotOrganics = TotEnergy = 50;
            TotResearch = 0;
            OwnSectors = new List<Sector>();
            AttackSector = 0;
        }
        public void CalcTurnGain()
        {// berechnet wie viele resourcen fp usw pro runde dazu kommen
            RoundMins = RoundEnergy = RoundLifeSupport = RoundTechPoints = 0;
            for (int i = 0; i < OwnSectors.Count; i++)
            {
                RoundMins += OwnSectors[i].Buildings[0].Level * OwnSectors[i].Ore;    // für die resourcen wird der basiswert des sectors mal den level der harvestingeinrichtung pro runde dazugewonnen
                RoundLifeSupport += OwnSectors[i].Buildings[1].Level * OwnSectors[i].Anorganics;
                RoundEnergy += OwnSectors[i].Buildings[2].Level * OwnSectors[i].Energy;
                RoundTechPoints += OwnSectors[i].Buildings[5].Level;   // jede stufe der forschungsanstalt erzeugt einen techpunkt pro runde
            }
        }
        public void AddTurnGain()
        {// fügt die resourcen für eine runde hinzu
            TotMinerals += RoundMins;    // für die resourcen wird der basiswert des sectors mal den level der harvestingeinrichtung pro runde dazugewonnen
            TotOrganics += RoundLifeSupport;
            TotEnergy += RoundEnergy;
            TotResearch += RoundTechPoints;   // jede stufe der forschungsanstalt erzeugt einen techpunkt pro runde
        }
    }
}
