﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary; 


namespace PlanetaryDomination
{
    [Serializable()] 
    public class Sector
    {
        public int X, Y, Number, Owner, Ore, Anorganics, Energy, BuildBuilding, BuildUnitID, UnitBuildCost;
        public List<bool> Examined; // array mit bool für jeden spieler das besagt ob der sektor bereits untersucht wurde (prospektor, nur einmal nötig), startsectoren sind automatisch untersucht
        public List<int> Scanning; // array mit int für jeden spieler das besagt mit welcher stärke der sektor gescannt wird,
        public static int NumberofPlayers;
        public List<Unit> Units;
        public List<Unit> Attackers;
        public List<Building> Buildings;
        public bool Moveable, Attackable;

        public Sector(int x, int y, int number)
        {
            X = x;
            Y = y;
            Number = number;
            BuildBuilding = BuildUnitID = -1;
            UnitBuildCost = 0;  // bestimmt wie viel der einheit bereits gebaut wurde (fabriklvl wird raufaddiert) und wenn >= baukosten wird einheit fertig, das bezieht sich auf production cost, die costen für resourcen werden am anfang einmalig abgezogen
            Owner = 8;  // 0-7 die spieler und 8 für unbesetzt
            Moveable = false;
            Attackable = false;
            Examined = new List<bool>();
            for (int i = 0; i < NumberofPlayers; i++)
            {
                Examined.Add(false);    // alle sectoren sind zu begin unerfroscht, der eigene wird bei der belegung gesetzt
            }
            Units = new List<Unit>();
            Attackers = new List<Unit>();
            Buildings = new List<Building>();
            Buildings.Add(new Building("Mine"));    // #0
            Buildings.Add(new Building("Greenhouse"));    // #1
            Buildings.Add(new Building("Powerplant"));    // #2
            Buildings.Add(new Building("Factory"));    // #3
            Buildings.Add(new Building("Barracks"));    // #4
            Buildings.Add(new Building("Academy"));    // #5
            Buildings.Add(new Building("Scanner"));    // #6
            Buildings.Add(new Building("Transport"));    // #7
        }
        public void ProcessTurn()
        {// berechnet die runde (bewegt einheiten?, baut gebäude und einheiten)
            if (-1 != BuildBuilding)
            {// es wird ein gebäude gebaut in diesem sektor also den bau vortschreiten lassen
                if (Buildings[BuildBuilding].BuildTurn())   // wenn gebäude fertig gebaut auch zurücksetzen damit man neues wählen muss
                    BuildBuilding = -1;
            }
            for (int i = 0; i < Units.Count; i++)
            {
                if (Units[i].ETA > 0)   // die einheit ist in bewegung also näherkommen lassen
                    --Units[i].ETA;
            }
        }
    }
}
