﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using RoundLineCode;
using Microsoft.Xna.Framework.Content;

namespace PlanetaryDomination
{
    public class SectorManager
    {// verwaltet die sektoren und zeigt sie an
        public List<Sector> SectorList;
        private GraphicsManager Graphics;
        InputManager Input;
        FontManager Fonts;
        SoundManager Sound;
        GameData Gamedata;
        public ViewManager Views;
        int NumberofSectors, SectorHeight, SectorZoomHeight, MouseSecX, MouseSecY, MouseSector, LastSelSector, LastHighlightSector, UpperLeftX, UpperLeftY, LowerRightX, LowerRightY, MoveStart, MoveEnd;
        Vector2 PosVector;
        float MouseScrX, MouseScrY, PixelHeight, SectorLength, ZoomSectorLength, HalfSectorLength;
        public List<Unit> CurrentBuildList; // speichert die einheiten die vom spieler in diesem sektor gebaut werden können
        bool Movemode, Attackmode;
        public Unit UnittoMove;
        public int ActSelSector;

        RoundLineManager roundLineManager;
        RoundLine MoveLine;
        Matrix viewMatrix,projMatrix;
        float cameraX = 400.0f, cameraY = -280.0f,cameraZoom = 300;
//        Disc dude = new Disc(0, 0);
        int roundLineTechniqueIndex = 0;
        string[] roundLineTechniqueNames;

        public SectorManager(GraphicsManager graphicman, InputManager inputman, FontManager fontman, SoundManager soundman, GameData gamedat, ContentManager content)
        {// constructor
            SectorList = new List<Sector>();
            CurrentBuildList = new List<Unit>();
            PosVector = new Vector2();
            Graphics = graphicman;
            Fonts = fontman;
            Input = inputman;
            Sound = soundman;
            Gamedata = gamedat;
            NumberofSectors = 0;
            PixelHeight = Graphics.ScrWidth * 0.5f;
            Movemode = Attackmode = false;
            roundLineManager = new RoundLineManager();
            roundLineManager.Init(Graphics.Device, content);
            roundLineTechniqueNames = roundLineManager.TechniqueNames;
            MoveLine = new RoundLine(10.0f, 10.0f, 790.0f, -370.0f);
            Create2DProjectionMatrix();
        }
        public void CreateSectors(int sectors,int players, int player)
        {// erzeugt die sektoren und belegt sie zufällig
            int i, column = 0, line = 0, sect;
            Sector tempsect;
            for (i = 3; i < 21; i++)
            {// prüfen ob anzahl stimmt in schleife formel ausrechnen und wenn am ende nicht gleich dann exception werfen
                if (i * i * 2 == sectors)
                {
                    NumberofSectors = sectors;
                    SectorZoomHeight = SectorHeight = i; // die höhe des spielfelds merken für später
                    break;
                }
            }
/*            SectorLength = PixelHeight / (float)SectorHeight;
            ZoomSectorLength = PixelHeight / (float)SectorZoomHeight; // die kantenlänge eines quadratischen sectors in pixel ausrechnen
            SectorLength = PixelHeight / (float)SectorHeight;
            HalfSectorLength = ZoomSectorLength * 0.5f; // und halbieren*/
            if (0 == NumberofSectors)
                throw (new Exception("Invalid Number of Sectors. Must be Height x Height x 2 with Height [2-20]!"));
            Random Rand = new Random();
            Sector.NumberofPlayers = players;
            for (i = 0; i < NumberofSectors; i++)   // sektoren initialisieren
            {
                tempsect = new Sector(column, line, i);
                SectorList.Add(tempsect);
                tempsect.Ore = Rand.Next(8) + 1; // rohstoffe für mine
                tempsect.Anorganics = Rand.Next(8) + 1; // rohstoffe für gewächshaus
                tempsect.Energy = Rand.Next(8) + 1; // rohstoffe für kraftwerk
                if (++column == SectorHeight * 2)
                {
                    column = 0;
                    ++line;
                }
            }
            for (i = 0; i < players; i++)
            {// die startsektoren der spieler verteilen
                do
                {
                    sect = Rand.Next(NumberofSectors);
                } while (8 != SectorList[sect].Owner);  // einen freien finden (keine abstandskontrolle oder so)
                tempsect = SectorList[sect];
                ChangeSectorOccupation(sect, i);
                for (int j = 0; j < 8; j++)
                {// sektor startet etwas ausgebaut also alle gebäude auf lvl 1 ausbauen
                    tempsect.Buildings[j].BuildTurn();
                }
                tempsect.Examined[i] = true;    // der startsector des spielers ist zu begin erforscht
                Gamedata.Players[i].CalcTurnGain();
            }
            ActSelSector = LastSelSector = LastHighlightSector = player;  // auswahl auf heimatsektor des spielers setzen
/*            UpperLeftX = UpperLeftY = 0;    // initial gesamtes spielfeld anzeigen
            LowerRightX = SectorHeight * 2 - 1;
            LowerRightY = SectorHeight - 1;*/
            CalcViewParams();
        }
        public void Update()
        {// maus usw auswerten
            viewMatrix = Matrix.CreateTranslation(-cameraX, -cameraY, 0) * Matrix.CreateScale(1.0f / cameraZoom, 1.0f / cameraZoom, 1.0f);
            MouseScrX = Input.GetMousePosX(); // update der koordinaten für die maus
            MouseScrY = Input.GetMousePosY();
            if ((MouseScrY < PixelHeight) && (MouseScrY > 0.0f) && (MouseScrX > 0.0f) && (MouseScrX < PixelHeight*2.0f))
            {// die maus ist im spielfeld also position usw als eingabe werten
                if ((Input.GetScrolled() < 0) && (SectorZoomHeight < SectorHeight))
                {// rauszoomen
                    SectorZoomHeight += 2;
                    UpperLeftX -= 2;
                    UpperLeftY -= 1;
                    LowerRightX += 2;
                    LowerRightY += 1;
                    if (UpperLeftX < 0)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        UpperLeftX = 0;
                        LowerRightX = SectorZoomHeight * 2 - 1;
                    }
                    if (UpperLeftY < 0)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        UpperLeftY = 0;
                        LowerRightY = SectorZoomHeight - 1;
                    }
                    if (LowerRightX > SectorHeight * 2 - 1)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        LowerRightX = SectorHeight * 2 - 1;
                        UpperLeftX = LowerRightX - SectorZoomHeight * 2 + 1;
                    }
                    if (LowerRightY > SectorHeight - 1)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        LowerRightY = SectorHeight - 1;
                        UpperLeftY = LowerRightY - SectorZoomHeight + 1;
                    }
                }
                if ((Input.GetScrolled() > 0) && (SectorZoomHeight > 2))
                {// reinzoomen
                    SectorZoomHeight -= 2; //# hier noch auf den gehighlighteten sector zentrieren falls möglich, aber dann brauch ich den schon oder den aus dem letzten frame merken?
                    if (MouseScrX < PixelHeight)
                    {// linke hälfte also lower right aus upper left ausrechnen
                        UpperLeftX = MouseSecX - SectorZoomHeight;      // mousesecx+y aus letztem frame
                        LowerRightX = UpperLeftX + SectorZoomHeight * 2 - 1;
                    }
                    else
                    {// rechte hälfte also upper left aus lower right ausrechnen
                        LowerRightX = MouseSecX + SectorZoomHeight;
                        UpperLeftX = LowerRightX - SectorZoomHeight * 2 + 1; // mousesecx+y aus letztem frame
                    }
                    if (MouseScrY < PixelHeight * 0.5f)
                    {// obere hälfte also lower right aus upper left ausrechnen
                        UpperLeftY = MouseSecY - SectorZoomHeight / 2;
                        LowerRightY = UpperLeftY + SectorZoomHeight - 1;
                    }
                    else
                    {// untere hälfte also upper left aus lower right ausrechnen
                        LowerRightY = MouseSecY + SectorZoomHeight / 2;
                        UpperLeftY = LowerRightY - SectorZoomHeight + 1;
                    }
                    if (UpperLeftX < 0)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        UpperLeftX = 0;
                        LowerRightX = SectorZoomHeight * 2 - 1;
                    }
                    if (UpperLeftY < 0)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        UpperLeftY = 0;
                        LowerRightY = SectorZoomHeight - 1;
                    }
                    if (LowerRightX > SectorHeight * 2 - 1)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        LowerRightX = SectorHeight * 2 - 1;
                        UpperLeftX = LowerRightX - SectorZoomHeight * 2 + 1;
                    }
                    if (LowerRightY > SectorHeight - 1)
                    {// durch zoom außerhalb spielfeld das korrigieren
                        LowerRightY = SectorHeight - 1;
                        UpperLeftY = LowerRightY - SectorZoomHeight + 1;
                    }
                }
                if ((Input.IsFirstPressed(Keys.Up)) && (UpperLeftY > 0))
                {// hochscrollen
                    --UpperLeftY;
                    --LowerRightY;
                }
                if ((Input.IsFirstPressed(Keys.Down)) && (LowerRightY < SectorHeight - 1))
                {// runterscrollen
                    ++UpperLeftY;
                    ++LowerRightY;
                }
                if ((Input.IsFirstPressed(Keys.Left)) && (UpperLeftX > 0))
                {// linksscrollen
                    --UpperLeftX;
                    --LowerRightX;
                }
                if ((Input.IsFirstPressed(Keys.Right)) && (LowerRightX < SectorHeight * 2 - 1))
                {// rechtsscrollen
                    ++UpperLeftX;
                    ++LowerRightX;
                }
                ZoomSectorLength = PixelHeight / (float)SectorZoomHeight; // die kantenlänge eines quadratischen sectors in pixel ausrechnen
                SectorLength = PixelHeight / (float)SectorHeight;
                HalfSectorLength = ZoomSectorLength * 0.5f; // und halbieren
                MouseSecX = (int)Math.Floor((float)SectorZoomHeight * MouseScrX / PixelHeight) + UpperLeftX;
                MouseSecY = (int)Math.Floor((float)SectorZoomHeight * MouseScrY / PixelHeight) + UpperLeftY;
                MouseSector = MouseSecY * SectorHeight * 2 + MouseSecX; // den index des sektors über dem sich maus befindet berechnen
                if (LastHighlightSector != MouseSector)
                {// ein anderer sector wird gehighlighted also sound spielen
                    LastHighlightSector = MouseSector;
                    Sound.PlaySound(2);
                }
                if (Movemode)
                {// bewegungsmodus aktiv
                    MoveEnd = MouseSector;  // wenn wir im Bewegungsmodus sind ziel fürs bewegen setzen
                    if (Input.IsFirstPressed(1))    // wenn im bewegungsmodus bei rmt bewegungsmodus abbrechen
                        Movemode = false;
                }
                if (Input.IsFirstPressed(0))
                {// maus wurde gedrückt also Sound spielen wenn neuer sektor ausgewählt
                    if (Movemode)   //# hier die anderen prüfungen machen
                    {// im movemode einheit mit linksklick bewegen falls möglich
                        if (SectorList[LastHighlightSector].Moveable)
                        {// prüfen ob es geht
                            MoveUnit(SectorList[ActSelSector], SectorList[LastHighlightSector], UnittoMove);
                        }
                        else
                        {//# ansonsten ton spielen
                        }
                        Movemode = false;   // in jedem fall movemode beenden
                    }
                    else if (Attackmode)
                    {
                        if (SectorList[LastHighlightSector].Attackable)
                        {// prüfen ob es geht
                            AttackSector(SectorList[ActSelSector], SectorList[LastHighlightSector], UnittoMove);
                        }
                        else
                        {//# ansonsten ton spielen
                        }
                        Attackmode = false;   // in jedem fall attackmode beenden
                    }
                    else
                    {// im normalen modus sektor auswählen
                        ActSelSector = MouseSector;
                        if (LastSelSector != ActSelSector)
                        {// neuer Sector ausgewählt also Sound spielen
                            LastSelSector = ActSelSector;
                            Sound.PlaySound(3);
                            if (Gamedata.HumanPlayer == SectorList[ActSelSector].Owner)
                                UpdateCurrentBuildList();
                        }
                    }
                }
            }
        }
        public void Draw()
        {// zeichnet die sektoren in einer schleife
            Sector tempsec;
            int bkgx = UpperLeftX * (int)SectorLength,bkgy = UpperLeftY * (int)SectorLength,i,j,unitcnt;  // linke obere ecke des sourcerechtecks bestimmen
            Graphics.DrawImagePart(0, 0, 1280, 640, bkgx, bkgy, (int)SectorLength * SectorZoomHeight * 2, (int)SectorLength * SectorZoomHeight, 1, 0.0f); //  hintergrund zeichnen
            for (i = 0; i < NumberofSectors; i++)
            {
                tempsec = ((Sector)(SectorList[i]));
                if ((tempsec.X >= UpperLeftX) && (tempsec.Y >= UpperLeftY) && (tempsec.X <= LowerRightX) && (tempsec.Y <= LowerRightY))
                {// abfragen ob sektor überhaupt sichtbar ist und nur dann zeichnen
                    PosVector = GetSectorScreenPosition(i, 0.5f, 0.5f);
//                    Graphics.SpriteBatch.DrawString(Fonts.GetFont(3), String.Format("{0}/{1}", tempsec.X, tempsec.Y), PosVector, Color.Red); // vectorpos
                    if (Movemode)
                    {
                        if(tempsec.Moveable)
                            Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 8, 0.0f);
                        else
                            Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 7, 0.0f);
                        if (((0 == UnittoMove.Type) && (tempsec.Examined[Gamedata.HumanPlayer])) || ((1 == UnittoMove.Type) && (tempsec.Owner == Gamedata.HumanPlayer)))
                        {// wenn prospektor für erforschte sektoren * anzeigen und wenn basemodule für besiedelte ebenfalls damit man im movemode besser unterscheiden kann was man noch machen muss und was nicht
                            PosVector = GetSectorScreenPosition(i, 0.05f, 0.05f);
                            Graphics.DrawText("*", PosVector, Color.White, 4); ;
                        }
                    }
                    if (Attackmode)
                    {
                        if (tempsec.Attackable)
                            Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 8, 0.0f);
                        else
                            Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 7, 0.0f);
                    }
                    if ((tempsec.Owner < 8) && (false == Movemode) && (false == Attackmode))
                    {// die farbe des besitzers zeichnen falls einer vorhanden (8 ist unbesetzt)
                        Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, tempsec.Owner + 7, 0.0f);
                    }
                    if (ActSelSector == tempsec.Number)
                    {// der selektierte sektor
                        Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 4, 0.0f);
                    }
                    else if (LastHighlightSector == tempsec.Number)
                    {// der gehighlightete sector
                        Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 2, 0.0f);
                    }
                    else
                    {// ein normaler sektor also nur den rand zeichnen
                        Graphics.DrawImagePart((int)(PosVector.X - HalfSectorLength), (int)(PosVector.Y - HalfSectorLength), (int)ZoomSectorLength, (int)ZoomSectorLength, 0, 0, 320, 320, 3, 0.0f);
                    }
                    if ((tempsec.Attackers.Count > 0) && (tempsec.Attackers[0].Owner == Gamedata.HumanPlayer))
                    {// der sektor wird von eigenen truppen angegriffen
                        PosVector = GetSectorScreenPosition(i, 0.35f, 0.75f);
                        Graphics.DrawText(String.Format("#{0}", tempsec.Attackers.Count), PosVector, Gamedata.Players[tempsec.Attackers[0].Owner].Playercolor, 5);
                    }
                    else if ((tempsec.Units.Count > 0) && (tempsec.Units[0].Owner == Gamedata.HumanPlayer))
                    {// wenn eigene einheiten anwesend (nicht in transit) ihre anzahl in der farbe des besitzers anzeigen
                        unitcnt = 0;
                        for (j = 0; j < tempsec.Units.Count; j++)
                        {
                            if (0 == tempsec.Units[j].ETA)
                                ++unitcnt;
                        }
                        PosVector = GetSectorScreenPosition(i, 0.3f, 0.75f);
                        Graphics.DrawText(String.Format("{0} +{1}", unitcnt, tempsec.Units.Count - unitcnt), PosVector, Gamedata.Players[tempsec.Units[0].Owner].Playercolor, 5);
                    }
                    if ((-1 == tempsec.BuildUnitID) && (Gamedata.HumanPlayer == tempsec.Owner))
                    {
                        PosVector = GetSectorScreenPosition(i, 0.1f, 0.25f);
                        Graphics.DrawText("No Unit Built", PosVector, Color.White, 3);
                    }
                    if ((-1 == tempsec.BuildBuilding) && (Gamedata.HumanPlayer == tempsec.Owner))
                    {
                        PosVector = GetSectorScreenPosition(i, 0.1f, 0.5f);
                        Graphics.DrawText("No Building Built", PosVector, Color.White, 3);
                    }
                    //# hier die sektordetails + werte zeichnen oder von sektoren selbst zeichnen lassen
                }
            }
            if (Movemode)
            {// einheit wird bewegt also farbige linie zwischen start und endsector zeichnen
                Graphics.SpriteBatch.End(); // alles bisherige zeichnen damit die linie drüber gemalt wird
                Matrix viewProjMatrix = viewMatrix * projMatrix;
                roundLineManager.NumLinesDrawn = 0;
                float lineRadius = 5;
                string curTechniqueName = roundLineTechniqueNames[roundLineTechniqueIndex];
                MoveLine.P0 = GetSectorCenter(ActSelSector);
                MoveLine.P1 = GetSectorCenter(LastHighlightSector);
                if(SectorList[LastHighlightSector].Moveable)
                    roundLineManager.Draw(MoveLine, lineRadius, Color.Green, viewProjMatrix, 0.0f, curTechniqueName);
                else
                    roundLineManager.Draw(MoveLine, lineRadius, Color.Red, viewProjMatrix, 0.0f, curTechniqueName);
                Graphics.SpriteBatch.Begin();   // und 2d zeichnen neu starten für texte usw
                if (SectorList[LastHighlightSector].Moveable)
                {
                    PosVector = GetSectorScreenPosition(LastHighlightSector, 0.35f, 0.75f);
                    Graphics.DrawText(String.Format("ETA: {0}", (int)Math.Ceiling((float)(GetSectorDistance(SectorList[ActSelSector], SectorList[LastHighlightSector])) / UnittoMove.Speed)), PosVector, Color.White, 4); ;
                }
                else
                {
                    PosVector = GetSectorScreenPosition(LastHighlightSector, 0.25f, 0.75f);
                    Graphics.DrawText(String.Format("Out of Range", (int)Math.Ceiling((float)(GetSectorDistance(SectorList[ActSelSector], SectorList[LastHighlightSector])) / UnittoMove.Speed)), PosVector, Color.White, 4); ;
                }
            }
            if (Attackmode)
            {// einheit wird bewegt also farbige linie zwischen start und endsector zeichnen
                Graphics.SpriteBatch.End(); // alles bisherige zeichnen damit die linie drüber gemalt wird
                Matrix viewProjMatrix = viewMatrix * projMatrix;
                roundLineManager.NumLinesDrawn = 0;
                float lineRadius = 5;
                string curTechniqueName = roundLineTechniqueNames[roundLineTechniqueIndex];
                MoveLine.P0 = GetSectorCenter(ActSelSector);
                MoveLine.P1 = GetSectorCenter(LastHighlightSector);
                if (SectorList[LastHighlightSector].Attackable)
                    roundLineManager.Draw(MoveLine, lineRadius, Color.Green, viewProjMatrix, 0.0f, curTechniqueName);
                else
                    roundLineManager.Draw(MoveLine, lineRadius, Color.Red, viewProjMatrix, 0.0f, curTechniqueName);
                Graphics.SpriteBatch.Begin();   // und 2d zeichnen neu starten für texte usw
                if (SectorList[LastHighlightSector].Attackable)
                {
                    PosVector = GetSectorScreenPosition(LastHighlightSector, 0.25f, 0.45f);
                    Graphics.DrawText("Attack", PosVector, Color.White, 4);
                }
                else
                {
                    PosVector = GetSectorScreenPosition(LastHighlightSector, 0.25f, 0.45f);
                    Graphics.DrawText("Invalid", PosVector, Color.Blue, 4);
                }
            }
            //# über unbekannte sektoren nebel des krieges legen (grau) aber so dass man die oberfläche noch sieht, evtl auch hud ausblenden ?,
            tempsec = ((Sector)(SectorList[LastHighlightSector]));
            Graphics.DrawText(String.Format("Mouse      : x {0}  y {1}  Player {2}", tempsec.X, tempsec.Y, Gamedata.Players[tempsec.Owner].Playername), new Vector2(10.0f, 650.0f), Gamedata.Players[tempsec.Owner].Playercolor, 4);
            tempsec = ((Sector)(SectorList[ActSelSector]));
            Graphics.DrawText(String.Format("Selection  : x {0}  y {1}  Player {2}", tempsec.X, tempsec.Y, Gamedata.Players[tempsec.Owner].Playername), new Vector2(10.0f, 675.0f), Gamedata.Players[tempsec.Owner].Playercolor, 4);
        }
        public Vector2 GetSectorScreenPosition(int sector, float x, float y)
        {
            Vector2 retval;
            Sector tempsec = SectorList[sector];
            retval.X = (tempsec.X - UpperLeftX) * ZoomSectorLength + x * SectorLength;
            retval.Y = (tempsec.Y - UpperLeftY) * ZoomSectorLength + y * SectorLength;
            return retval;
        }
        public void Serialize(BinaryFormatter binFormatter, FileStream fileStream)
        {// schreibt die daten in den stream
            binFormatter.Serialize(fileStream, SectorList);
        }
        public void Deserialize(BinaryFormatter binFormatter, FileStream fileStream)
        {// liest die daten aus dem stream
            SectorList = (List<Sector>)binFormatter.Deserialize(fileStream);
        }
        public Sector GetActSector()
        {
            return SectorList[ActSelSector];
        }
        private void ChangeSectorOccupation(int sector, int player)
        {// ändert den sector in der besitzliste der spieler und updated die berechnung des rundeneinkommes für beide
            if (SectorList[sector].Owner != 8)
            {// sector ist bereits von spieler besetzt also da entfernen
                for (int i = 0; i < Gamedata.Players[SectorList[sector].Owner].OwnSectors.Count;i++ )
                {// den sektor beim alten player löschen
                    if (Gamedata.Players[SectorList[sector].Owner].OwnSectors[i].Number == SectorList[sector].Number)
                        Gamedata.Players[SectorList[sector].Owner].OwnSectors.RemoveAt(i);
                }
            }
            SectorList[sector].Owner = player;
            Gamedata.Players[player].OwnSectors.Add(SectorList[sector]);
        }
        public void Turn()
        {
            Sector tempsect;
            for (int i = 0; i < SectorList.Count; i++)
            {// baut alle gebäude
                tempsect = SectorList[i];
                tempsect.ProcessTurn();    // baut gebäude
                if (-1 != tempsect.BuildUnitID)
                {// es wird eine Einheit gebaut also fortschreiten lassen
                    tempsect.UnitBuildCost += tempsect.Buildings[3].Level;    // den level der fabrik als fortschritt für die production cost draufaddieren, wenn sich fabriklevel während bau ändert fließt das also ein
                    if (tempsect.UnitBuildCost >= Gamedata.Players[tempsect.Owner].Units.Technologies[tempsect.BuildUnitID].ProductionCost)
                    {// einheit ist fertig gestellt also sie zum sektor und spieler hinzufügen
                        Unit tempunit = new Unit(Gamedata.Players[tempsect.Owner].Units.Technologies[tempsect.BuildUnitID]);
                        tempunit.Owner = tempsect.Owner;
                        tempsect.Units.Add(tempunit);
                        Gamedata.Players[tempsect.Owner].Units.Units.Add(tempunit);   // die einheit bei sector und spieler einfügen damit beide sie verwalten können
                        tempsect.UnitBuildCost = 0;    // baufortschritt zurücksetzen
                        tempsect.BuildUnitID = -1; // nichts bauen
                    }
                }
                if (tempsect.Attackers.Count > 0)
                {// sector wird angegriffen
                    BattleAI fight = new BattleAI(tempsect, Gamedata, ((BattleView)(Views.Views[4])).BattleMan);
                    if (0 == tempsect.Units.Count)
                    {// niemand zum verteidigen da also sektor direkt übernehmen
                        Gamedata.Players[tempsect.Owner].OwnSectors.Remove(tempsect);
                        tempsect.Owner = tempsect.Attackers[0].Owner;
                        Gamedata.Players[tempsect.Owner].OwnSectors.Add(tempsect);
                        for (int z = 0; z < tempsect.Attackers.Count; z++)
                        {
                            Gamedata.Players[tempsect.Owner].Units.Units.Add(tempsect.Attackers[z]);
                            tempsect.Units.Add(tempsect.Attackers[z]);
                        }
                        tempsect.Attackers.Clear();
                    }
/*                    else if ((Gamedata.HumanPlayer == tempsect.Attackers[0].Owner) || ((tempsect.Units.Count > 0) && (tempsect.Units[0].Owner == Gamedata.HumanPlayer)) || (tempsect.Owner == Gamedata.HumanPlayer))
                    {// spieler ist betroffen also anzeigen
                        fight.Playerfight();
                        ((BattleView)(Views.Views[4])).Init(fight); // auf neuen kampf zurücksetzen
                        Views.SwitchView(4);    // kampfschirm anzeigen
                    }*/
                    else
                    {// spieler ist nicht betroffen also automatisch ablaufen lassen
                        fight.Autofight();
                    }
                }
            }
        }
        private void UpdateCurrentBuildList()
        {// befüllt die liste mit allen einheiten die unter den gegebenen bedingungen (resourcen, fabriklevel, platz) gebaut werden können
            CurrentBuildList.Clear();
            Player player = Gamedata.Players[Gamedata.HumanPlayer];
            List<Unit> Techlist = player.Units.Technologies;
            if (GetActSector().Units.Count < GetActSector().Buildings[4].Level + 4)
            {// prüfen ob eine einheit überhaupt platz im sektor hat
                for (int i = 0; i < Techlist.Count; i++)
                {// alle techs (einheitenmodelle) durchgehen
                    if ((Techlist[i].MinFactoryLevel <= GetActSector().Buildings[3].Level) && (Techlist[i].MinCost <= player.TotMinerals) && (Techlist[i].OrgCost <= player.TotOrganics) && (Techlist[i].EnergyCost <= player.TotEnergy) && (Techlist[i].MinTechLevel <= player.TotResearch))
                    {// alle bedingungen erfüllt also einheit in baubare einfügen
                        CurrentBuildList.Add(Techlist[i]);
                    }
                }
            }
        }
        public void SetMoveMode(int startsect, Unit moveunit)
        {// eine linie zwischen startsect und highlightsect zeichnen und unit bei click in neuen sector einfügen und eta setzen
            Movemode = true;
            UnittoMove = moveunit;
            MoveStart = startsect;
            MoveEnd = startsect;
            Sector tempsect;
            for (int i = 0; i < SectorList.Count; i++)
            {
                tempsect = SectorList[i];
                if ((tempsect.Owner == 8) && (tempsect.Units.Count <= tempsect.Buildings[4].Level + 4) && ((0 == tempsect.Units.Count) || (tempsect.Units[0].Owner == Gamedata.HumanPlayer)))
                {// sektor unbewohnt also prüfen ob in reichweite und ob überhaupt platz ist im zielsector
                    if (GetClosestOwnSectorDist(SectorList[i]) <= moveunit.PlanetMoveRange)
                    {
                        tempsect.Moveable = true;
                    }
                }
                else if ((tempsect.Owner == Gamedata.HumanPlayer) && (tempsect.Units.Count <= tempsect.Buildings[4].Level + 4))
                {// eigenes territorium also überallhin bewegen wenn platz ist im zielsector
                    tempsect.Moveable = true;
                }
                else
                {// feindgebiet also nicht hin bewegen (nur angreifen)
                    tempsect.Moveable = false;
                }
            }
        }
        public int GetClosestOwnSectorDist(Sector refsect)
        {// geht alle sektoren durch und gibt den kleinsten abstand eines eigenen sectors zum referenzsector zurück
            int mindist = 10000, i, dist = 10000;
            if (refsect.Owner == Gamedata.HumanPlayer)  // der fragliche sector gehört bereits dem spieler also ist der abstand 0
                mindist = 0;
            else
            {// den abstand rausfinden
                for (i = 0; i < SectorList.Count; i++)
                {// alle sektoren durchgehen
                    if (SectorList[i].Owner == Gamedata.HumanPlayer)    // wenn sie spieler gehören den abstand bestimmen
                        dist = GetSectorDistance(refsect, SectorList[i]);
                    if (dist < mindist)
                    {// eigener sector ist näher dran also abstand merken
                        mindist = dist;
                    }
                }
            }
            return mindist;
        }
        public void Create2DProjectionMatrix()
        {// Create a simple 2D projection matrix (matrix ignores Z and just squishes X or Y to balance the upcoming viewport stretch)
            float projScaleX,projScaleY,width = Graphics.Device.Viewport.Width,height = Graphics.Device.Viewport.Height;
            if (width > height)
            {// Wide window
                projScaleX = height / width;
                projScaleY = 1.0f;
            }
            else
            {// Tall window
                projScaleX = 1.0f;
                projScaleY = width / height;
            }
            projMatrix = Matrix.CreateScale(projScaleX, projScaleY, 0.0f);
            projMatrix.M43 = 0.5f;
        }
        public Vector2 GetSectorCenter(int sector)
        {// liefert die transformierten bildschirmkoordinaten des sektorzentrums
            Vector2 result;
            result.X = 800.0f * (float)(SectorList[sector].X - UpperLeftX) / (float)(LowerRightX - UpperLeftX + 1) + 400.0f / (float)(LowerRightX - UpperLeftX + 1);
            result.Y = -400.0f * (float)(SectorList[sector].Y - UpperLeftY) / (float)(LowerRightY - UpperLeftY + 1) - 100.0f / (float)(LowerRightY - UpperLeftY + 1);
            return result;
        }
        public int GetSectorDistance(Sector sec1, Sector sec2)
        {// bestimmt den Abstand zwischen den beiden sektoren aber als dx+dy also keine diagonale
            return Math.Max(sec1.X, sec2.X) - Math.Min(sec1.X, sec2.X) + Math.Max(sec1.Y, sec2.Y) - Math.Min(sec1.Y, sec2.Y);
        }
        public void MoveUnit(Sector fromsec, Sector tosec, Unit unit)
        {// bewegt die einheit in den gewünschten sektor (eta wird gesetzt und jede runde dekrementiert bis sie da ist)
            tosec.Units.Add(unit);
            fromsec.Units.Remove(unit);
            unit.ETA = (int)Math.Ceiling((float)(GetSectorDistance(fromsec, tosec))/unit.Speed);
        }
        public bool NeighbourSectorAttackable()
        {// bestimmt ob mindestens 1 nachbarsektor angreifbar ist (feind sitzt drin bzw hat einheit dort)
            bool attackable = false;
            Sector tempsec;
            for (int i = 0; i < SectorList.Count; i++)
            {
                tempsec = SectorList[i];
                if ((i != ActSelSector) && (1 >= GetSectorDistance(tempsec, SectorList[ActSelSector])))
                {// nicht der gerade ausgewählte sector und in der nähe
                    if (tempsec.Attackers.Count > 0)
                    {// sector wird schon angegirffen also prüfen ob von spieler oder einem anderen
                        if (tempsec.Attackers[0].Owner == Gamedata.HumanPlayer)
                        {// in sektor den spieler angreift kann man mehr einheiten schicken, wenn sektor von ki angegriffen wird ist er nicht durch spieler angreifbar
                            tempsec.Attackable = true;
                            attackable = true;
                        }
                        else
                            tempsec.Attackable = false;
                    }
                    else if (((Gamedata.HumanPlayer != tempsec.Owner) && (8 != tempsec.Owner)) || ((8 == tempsec.Owner) && (tempsec.Units.Count > 0) && (tempsec.Units[0].Owner != Gamedata.HumanPlayer)))
                    {// sektor wird noch nicht angegriffen also angreifbar setzen
                        tempsec.Attackable = true;
                        attackable = true;
                    }
                    else
                    {
                        tempsec.Attackable = false;
                    }
                }
                else
                {
                    tempsec.Attackable = false;
                }
            }
            return attackable;
        }
        public void SetAttackMode(int startsect, Unit moveunit)
        {// eine linie zwischen startsect und highlightsect zeichnen und unit bei click in neuen sector einfügen und eta setzen
            Attackmode = true;
            MoveStart = startsect;
            MoveEnd = startsect;
            UnittoMove = moveunit;
        }
        public void AttackSector(Sector fromsec, Sector tosec, Unit unit)
        {// greift einen sector an
            tosec.Attackers.Add(unit);
            fromsec.Units.Remove(unit);
        }
        public void CalcViewParams()
        {// bestimmt die anzeigeparameter
            NumberofSectors = SectorList.Count;
            SectorZoomHeight = SectorHeight = (int)Math.Sqrt((double)(NumberofSectors / 2));
            SectorLength = PixelHeight / (float)SectorHeight;
            ZoomSectorLength = PixelHeight / (float)SectorZoomHeight; // die kantenlänge eines quadratischen sectors in pixel ausrechnen
            SectorLength = PixelHeight / (float)SectorHeight;
            HalfSectorLength = ZoomSectorLength * 0.5f; // und halbieren
            UpperLeftX = UpperLeftY = 0;    // initial gesamtes spielfeld anzeigen
            LowerRightX = SectorHeight * 2 - 1;
            LowerRightY = SectorHeight - 1;
        }
    }
}
