﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public class TextureManager
    {// verwaltet die Texturen
        private List<Texture2D> TextureList;    // liste die alle Texturen speichert
        public GraphicsManager Graphics;

        public TextureManager(ContentManager content, GraphicsManager graphman)
        {// constructor der Liste initialisiert
            Graphics = graphman;
            TextureList = new List<Texture2D>();
            TextureList.Add(content.Load<Texture2D>("MouseCursorImage"));  // #0
            TextureList.Add(content.Load<Texture2D>("Hintergrund"));  // #1
            TextureList.Add(content.Load<Texture2D>("Highlighted"));  // #2
            TextureList.Add(content.Load<Texture2D>("Sector"));  // #3
            TextureList.Add(content.Load<Texture2D>("Selektiert"));  // #4
            TextureList.Add(content.Load<Texture2D>("ButtonBackground"));  // #5
            TextureList.Add(content.Load<Texture2D>("ButtonHighlight"));  // #6
        }
        public Texture2D GetTexture(int textureindex)
        {// liefert die gewünschte Font zurück
            return TextureList[textureindex];
        }
        private Texture2D CreateTexture(int width, int height, uint color)
        {// erzeugt eine textur und füllt sie homogen mit angegebener farbe
            Texture2D texture = new Texture2D(Graphics.Device, width, height);
            int i, size = texture.Width * texture.Height;
            uint[] pixels = new uint[size];
            for (i = 0; i < size; i++)
            {
                pixels[i] = color;
            }
            texture.SetData(pixels);
            return texture;
        }
        public void Init()
        {// seperat initialiseren weil vorher kein zugrif auf das graphics device möglich ist (wie macht das xna dann bei load content?)
            TextureList.Add(CreateTexture(320, 320, 0x4bff0000));  // #7  rot 20%
            TextureList.Add(CreateTexture(320, 320, 0x4b00ff00));  // #8  grün 20%
            TextureList.Add(CreateTexture(320, 320, 0x4b0000ff));  // #9  blau 20%
            TextureList.Add(CreateTexture(320, 320, 0x4bffff00));  // #10  gelb 20%
            TextureList.Add(CreateTexture(320, 320, 0x4bff00ff));  // #11  magenta 20%
            TextureList.Add(CreateTexture(320, 320, 0x4b00ffff));  // #12  cyan 20%
            TextureList.Add(CreateTexture(320, 320, 0x64a52a2a));  // #13  braun 20%
            TextureList.Add(CreateTexture(320, 320, 0x64f5deb3));  // #14  weizen 20%
        }
    }
}
