﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;
using System.IO;
using System.Reflection;

namespace PlanetaryDomination
{
    [Serializable()]
    public class UnitManager
    {
        public List<Unit> Units;// liste mit allen einheiten eines spielers
        public List<Unit> Technologies; // liste mit allen zur Verfügung stehenden Einheiten (die gebaut werden können), sind alle von anfang an vorhanden und werden durch den techlevel der forschung "freigeschaltet"

        public UnitManager()
        {
            Units = new List<Unit>();
            Technologies = new List<Unit>();
            LoadTechTree("\\TechQueue.xml");
            for (int i = 0; i < Technologies.Count; i++)
            {// den techlistindex befüllen
                Technologies[i].Techlistindex = i;
            }
        }
        public void LoadTechTree(String filename)
        {// lädt die daten für technologien aus der datei
            try
            {
                TextReader FileReader = new StreamReader(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location) + filename);
                XmlSerializer XMLSerializer = new XmlSerializer(typeof(List<Unit>));
                Technologies = (List<Unit>)XMLSerializer.Deserialize(FileReader);
                FileReader.Close();
            }
            catch (SerializationException e)
            {// die Datei kann nicht deserialisiert werden
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
            catch (IOException e)
            {// Beim Versuch, die Datei zu öffnen, ist ein Fehler aufgetreten
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
        }
        public void SaveTechTree(String filename)
        {// lädt die daten für technologien aus der datei
            try
            {
                StreamWriter FileWriter = new StreamWriter(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location) + "\\TechQueue.xml");
                XmlSerializer XMLSerializer = new XmlSerializer(typeof(List<Unit>));
                XMLSerializer.Serialize(FileWriter, Technologies);
                FileWriter.Close();
            }
            catch (SerializationException e)
            {// die Datei kann nicht serialisiert werden
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
            catch (IOException e)
            {// Beim Versuch, die Datei zu öffnen, ist ein Fehler aufgetreten
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
        }
    }
}
